import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.GregorianCalendar;
import java.util.HashMap;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;

import org.xmldb.api.base.XMLDBException;

public class Calendrier extends JPanel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private JLabel lblMonth, lblYear;
	private JButton precedent, suivant;
	private static JTable calendrier;
	private JComboBox cmbYear;

	private static DefaultTableModel modeleTable; //Table model
	private JScrollPane spCalendrier; //The scrollpane
	private static int realYear, realMonth, realDay, currentDay, currentYear, currentMonth;

	static HashMap<String, Evenement> stockEvenements = new HashMap<String,Evenement>() ;
	static HashMap<String,String> correspondanceIndiceCode = new HashMap<String,String>();
	static HashMap<String, Integer> correspondanceHeureIndice = new HashMap<String, Integer>();

	public Calendrier() {
		correspondanceHeureIndice.put("00:00",0);
		correspondanceHeureIndice.put("00:30",1);
		correspondanceHeureIndice.put("01:00",2);
		correspondanceHeureIndice.put("01:30",3);
		correspondanceHeureIndice.put("02:00",4);
		correspondanceHeureIndice.put("02:30",5);
		correspondanceHeureIndice.put("03:00",6);
		correspondanceHeureIndice.put("03:30",7);
		correspondanceHeureIndice.put("04:00",8);
		correspondanceHeureIndice.put("04:30",9);
		correspondanceHeureIndice.put("05:00",10);
		correspondanceHeureIndice.put("05:30",11);
		correspondanceHeureIndice.put("06:00",12);
		correspondanceHeureIndice.put("07:00",14);
		correspondanceHeureIndice.put("07:30",15);
		correspondanceHeureIndice.put("08:00",16);
		correspondanceHeureIndice.put("08:30",17);
		correspondanceHeureIndice.put("09:00",18);
		correspondanceHeureIndice.put("09:30",19);
		correspondanceHeureIndice.put("10:00",20);
		correspondanceHeureIndice.put("10:30",21);
		correspondanceHeureIndice.put("11:00",22);
		correspondanceHeureIndice.put("11:30",23);
		correspondanceHeureIndice.put("12:00",24);
		correspondanceHeureIndice.put("12:30",25);
		correspondanceHeureIndice.put("13:00",26);
		correspondanceHeureIndice.put("13:30",27);
		correspondanceHeureIndice.put("14:00",28);
		correspondanceHeureIndice.put("14:30",29);
		correspondanceHeureIndice.put("15:00",30);
		correspondanceHeureIndice.put("15:30",31);
		correspondanceHeureIndice.put("16:00",32);
		correspondanceHeureIndice.put("16:30",33);
		correspondanceHeureIndice.put("17:00",34);
		correspondanceHeureIndice.put("17:30",35);
		correspondanceHeureIndice.put("18:00",36);
		correspondanceHeureIndice.put("18:30",37);
		correspondanceHeureIndice.put("19:00",38);
		correspondanceHeureIndice.put("19:30",39);
		correspondanceHeureIndice.put("20:00",40);
		correspondanceHeureIndice.put("20:30",41);
		correspondanceHeureIndice.put("21:00",42);
		correspondanceHeureIndice.put("21:30",43);
		correspondanceHeureIndice.put("22:00",44);
		correspondanceHeureIndice.put("22:30",45);
		correspondanceHeureIndice.put("23:00",46);
		correspondanceHeureIndice.put("23:30",47);
		this.setLayout(null);

		//Create controls
		lblMonth = new JLabel ("Janvier");
		lblMonth.setHorizontalAlignment(SwingConstants.CENTER);
		lblYear = new JLabel ("Anne:");
		cmbYear = new JComboBox();
		cmbYear.addActionListener(new cmbYear_Action());
		this.precedent = new JButton ("<<");
		this.precedent.addActionListener(new btnPrev_Action());
		this.suivant = new JButton (">>");
		this.suivant.addActionListener(new btnNext_Action());
		Calendrier.modeleTable = new DefaultTableModel(){
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public boolean isCellEditable(int rowIndex, int mColIndex){
				return false;
			}
		};
		Calendrier.calendrier = new JTable(modeleTable);
		this.spCalendrier = new JScrollPane(calendrier);

		//Add controls to pane
		this.add(this.lblMonth);
		this.add(this.lblYear);
		this.add(this.cmbYear);
		this.add(this.precedent);
		this.add(this.suivant);
		this.add(spCalendrier);

		//Set bounds
		this.setBounds(0, 0, 320, 335);
		lblMonth.setBounds(150, 25, 80, 25);
		lblYear.setBounds(10, 305, 80, 20);
		cmbYear.setBounds(230, 305, 80, 20);
		this.precedent.setBounds(10, 25, 57, 25);
		this.suivant.setBounds(352, 25, 57, 25);
		spCalendrier.setBounds(10, 50, 400, 300);

		//Get real month/year
		GregorianCalendar cal = new GregorianCalendar(); //Create calendar
		realDay = cal.get(GregorianCalendar.DAY_OF_MONTH); //Get day
		realMonth = cal.get(GregorianCalendar.MONTH); //Get month
		realYear = cal.get(GregorianCalendar.YEAR); //Get year
		currentMonth = realMonth; //Match month and year
		currentYear = realYear;

		//Add headers
		String[] headers = {"Dimanche", "Lundi", "Mardi", "Mercredi", "Jeudi", "Vendredi", "Samedi"}; //All headers
		for (int i=0; i<7; i++){
			modeleTable.addColumn(headers[i]);
		}

		calendrier.getParent().setBackground(calendrier.getBackground()); //Set background

		//No resize/reorder
		calendrier.getTableHeader().setResizingAllowed(false);
		calendrier.getTableHeader().setReorderingAllowed(false);

		//Single cell selection
		calendrier.setColumnSelectionAllowed(true);
		calendrier.setRowSelectionAllowed(true);
		calendrier.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		//Set row/column count
		calendrier.setRowHeight(38);
		modeleTable.setColumnCount(7);
		modeleTable.setRowCount(6);

		//Populate table
		for (int i=realYear-100; i<=realYear+100; i++){
			cmbYear.addItem(String.valueOf(i));
		}

		//Refresh calendar
		rafraichir(realMonth, realYear); //Refresh calendar



		calendrier.setRowSelectionAllowed(true);
		calendrier.setColumnSelectionAllowed(true);
		calendrier.setCellSelectionEnabled(true);


		calendrier.getSelectionModel().addListSelectionListener(
				new ListSelectionListener() { 	
					public void valueChanged(ListSelectionEvent evt) {
						// Coordonnes de la cellule slctionne
						int selectedRow = calendrier.getSelectedRow();
						int selectedColumn = calendrier.getSelectedColumn();

						String s = calendrier.getValueAt(selectedRow,selectedColumn).toString();
						System.out.println("contenu:"+s);
						Calendrier.currentDay=Integer.parseInt(s);
						Calendrier.correspondanceIndiceCode.clear();
						Calendrier.stockEvenements.clear();
						//Clear table
						for (int i=0; i<46; i++){
							Interface.modele.setValueAt(null, i, 1);
						}
						try {
							Interface.database.printEvenementDate(s,String.valueOf(currentMonth+1).toString(),String.valueOf(currentYear));
						} catch (XMLDBException e) {
							e.printStackTrace();
						}catch(NullPointerException e){
							System.out.println("Click en dehors.");
						}
						//Requete Christophe pour rcup les venements
					}
				}


		);

		calendrier.getColumnModel().getSelectionModel().addListSelectionListener(
				new ListSelectionListener() {
					public void valueChanged(ListSelectionEvent evt) {
						// Coordonnes de la cellule slctionne
						//calendrier.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

						try {
							int selectedRow = calendrier.getSelectedRow();
							int selectedColumn = calendrier.getSelectedColumn();
							String s = calendrier.getValueAt(selectedRow,selectedColumn).toString();
							System.out.println("contenu:"+s);
	
							//Clear table
							for (int i=0; i<46; i++){
								Interface.modele.setValueAt(null, i, 1);
							}
							Calendrier.correspondanceIndiceCode.clear();
							Calendrier.stockEvenements.clear();
						
							Interface.database.printEvenementDate(s,String.valueOf(currentMonth+1).toString(),String.valueOf(currentYear));
						} catch (XMLDBException e) {
							// TODO Auto-generated catch block
							e.printStackTrace();
						}catch(ArrayIndexOutOfBoundsException e){
							System.out.println("Click en dehors.");
						}catch(NullPointerException e){
							System.out.println("Click en dehors.");
						}
					}
				});


	}

	public void rafraichir(int month, int year){
		//Variables
		String[] months =  {"Janvier", "Fvrier", "Mars", "Avril", "Mai", "Juin", "Juillet", "Aot", "Septembre", "Octobre", "Novembre", "Decembre"};
		int nod, som; //Number Of Days, Start Of Month

		//Allow/disallow buttons
		this.precedent.setEnabled(true);
		this.suivant.setEnabled(true);
		if (month == 0 && year <= realYear-10){this.precedent.setEnabled(false);} //Too early
		if (month == 11 && year >= realYear+100){this.suivant.setEnabled(false);} //Too late
		lblMonth.setText(months[month]); //Refresh the month label (at the top)
		lblMonth.setBounds(160-lblMonth.getPreferredSize().width/2, 25, 180, 25); //Re-align label with calendar
		cmbYear.setSelectedItem(String.valueOf(year)); //Select the correct year in the combo box

		//Clear table
		for (int i=0; i<6; i++){
			for (int j=0; j<7; j++){
				modeleTable.setValueAt(null, i, j);
			}
		}

		//Get first day of month and number of days
		GregorianCalendar cal = new GregorianCalendar(year, month, 1);
		nod = cal.getActualMaximum(GregorianCalendar.DAY_OF_MONTH);
		som = cal.get(GregorianCalendar.DAY_OF_WEEK);

		//Draw calendar
		for (int i=1; i<=nod; i++){
			int row = new Integer((i+som-2)/7);
			int column  =  (i+som-2)%7;
			modeleTable.setValueAt(i, row, column);
		}

		//Apply renderers
		Calendrier.calendrier.setDefaultRenderer(Calendrier.calendrier.getColumnClass(0), new tblCalendarRenderer());
	}

	//Permet d'ajouter un evenement dans le tableau  droite
	/*A FAIRE
	 * GERER LA DUREE
	 */
	public static void ajoutLigneEvenement(String p_code, String p_type, String sujet, String jour, String mois, String annee,
			String heure, String duree, String endroit, String rue, String cp,
			String ville, String pays, String salle, String commentaire){
		Evenement e = new Evenement(p_code, p_type, sujet, jour, mois, annee, heure, duree, endroit, rue, cp, ville, pays, salle, commentaire);

		stockEvenements.put(p_code, e);
		System.out.println("On vient d'ajouter "+correspondanceHeureIndice.get(heure)+","+p_code+" dans correspondanceIndiceCode");
		Calendrier.correspondanceIndiceCode.put(""+correspondanceHeureIndice.get(heure),p_code);
		System.out.println("On vient de put dans correspondanceIndiceCode:"+correspondanceHeureIndice.get(heure)+","+p_code);
		System.out.println("on verifie:"+correspondanceIndiceCode.get(""+correspondanceHeureIndice.get(heure)));
		System.out.println("heure:"+heure);
		Interface.horaires.setValueAt(sujet, correspondanceHeureIndice.get(heure),1);

	}

	static class tblCalendarRenderer extends DefaultTableCellRenderer{
		/**
		 * 
		 */
		private static final long serialVersionUID = 1L;

		public Component getTableCellRendererComponent (JTable table, Object value, boolean selected, boolean focused, int row, int column){
			super.getTableCellRendererComponent(table, value, selected, focused, row, column);
			if (column == 0 || column == 6){ //Week-end
				setBackground(new Color(255, 220, 220));
			}
			else{ //Week
				setBackground(new Color(255, 255, 255));
			}
			if (value != null){
				if (Integer.parseInt(value.toString()) == realDay && currentMonth == realMonth && currentYear == realYear){ //Today
					setBackground(new Color(220, 220, 255));
					//Requete Christophe
					try {
						System.out.println("on affiche les evenement du "+currentDay+"/"+currentMonth+"/"+currentYear);
						Interface.database.printEvenementDate(String.valueOf(realDay).toString(),String.valueOf(realMonth+1).toString(),String.valueOf(realYear));
					} catch (XMLDBException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}else{
					//Fonction christophe qui me dit si y a un truc le jour en question 
					boolean contenu;
					try {
						contenu = Interface.database.isEventDay(value.toString(),""+(currentMonth+1),""+currentYear);
						if (contenu) {
							setBackground(new Color(255,255,150));
						}
					} catch (XMLDBException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
			setBorder(null);
			setForeground(Color.black);
			return this;  
		}
	}

	//Listeners
	class btnPrev_Action implements ActionListener{
		public void actionPerformed (ActionEvent e){
			if (currentMonth == 0){ //Back one year
				currentMonth = 11;
				currentYear -= 1;
			}
			else{ //Back one month
				currentMonth -= 1;
			}
			rafraichir(currentMonth, currentYear);
		}
	}


	class btnNext_Action implements ActionListener{
		public void actionPerformed (ActionEvent e){
			if (currentMonth == 11){ //Foward one year
				currentMonth = 0;
				currentYear += 1;
			}
			else{ //Foward one month
				currentMonth += 1;
			}
			rafraichir(currentMonth, currentYear);
		}
	}

	class cmbYear_Action implements ActionListener{
		public void actionPerformed (ActionEvent e){
			if (cmbYear.getSelectedItem() != null){
				String b = cmbYear.getSelectedItem().toString();
				currentYear = Integer.parseInt(b);
				rafraichir(currentMonth, currentYear);
			}
		}
	}

	public static int getRealYear() {
		return realYear;
	}

	public static void setRealYear(int realYear) {
		Calendrier.realYear = realYear;
	}

	public static int getRealMonth() {
		return realMonth;
	}

	public static void setRealMonth(int realMonth) {
		Calendrier.realMonth = realMonth;
	}

	public static int getRealDay() {
		return realDay;
	}

	public static void setRealDay(int realDay) {
		Calendrier.realDay = realDay;
	}

	public static int getCurrentYear() {
		return currentYear;
	}

	public static void setCurrentYear(int currentYear) {
		Calendrier.currentYear = currentYear;
	}

	public static int getCurrentMonth() {
		return currentMonth;
	}

	public static void setCurrentMonth(int currentMonth) {
		Calendrier.currentMonth = currentMonth;
	}

	public static int getCurrentDay() {
		return currentDay;
	}

	public static void setCurrentDay(int currentDay) {
		Calendrier.currentDay = currentDay;
	}



}
