

import org.xmldb.api.base.XMLDBException;

public class DatabaseExistLink 
{
	private int code = 0; 
	
	private UseDataBase udb;
	private UseDomForAgenda udfa;
	
	//Gestion gnrale de la base
	
	public DatabaseExistLink() throws ClassNotFoundException, InstantiationException, IllegalAccessException, XMLDBException
	{
		this.udb = new UseDataBase();
		this.udfa = new UseDomForAgenda(udb.getAgenda(),udb.getContactsAsDom(), udb.getCalendrierAsDom());
		this.code = this.udfa.initCodeContact(this.code);
		this.code = this.udfa.initCodeEvenement(this.code);
		this.udb.saveContacts(udfa.getContacts());
		this.udb.saveCalendrier(udfa.getCalendrier());
	}
	
	public void closeDatabase()
	{
		udb.saveContacts(udfa.getContacts());
		udb.saveCalendrier(udfa.getCalendrier());
		udb.closeAgenda();
		udfa = null;
	}
	
	//Gestion des contacts
	
	public boolean addContact(
			String p_type,
			String p_nom,
			String p_prenom,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_email_pers,
			String p_email_prof,
			String p_fixe,
			String p_portable,
			String p_professionnel,
			String p_intitule,
			String p_raison_sociale,
			String p_rue_s,
			String p_cp_s,
			String p_ville_s,
			String p_pays_s,
			String p_web,
			String p_commentaire
		)
	{
		udfa.addContact(udfa.createContactWithNS("C"+this.code, p_type, p_nom, p_prenom, p_rue, p_cp, p_ville, p_ville, p_jour, p_mois, p_annee, p_email_pers, p_email_prof, p_fixe, p_portable, p_professionnel, p_intitule, p_raison_sociale, p_rue_s, p_cp_s, p_ville_s, p_pays_s, p_web, p_commentaire));
		this.code++;
		udb.saveContacts(udfa.getContacts());
		return false;
	}
	
	public boolean removeContact(String code)
	{
		udfa.removeContact(code);
		udb.saveContacts(udfa.getContacts());
		System.out.println("code:"+code);
		return false;
	}
	
	public boolean updateContact(
			String p_code,
			String p_type,
			String p_nom,
			String p_prenom,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_email_pers,
			String p_email_prof,
			String p_fixe,
			String p_portable,
			String p_professionnel,
			String p_intitule,
			String p_raison_sociale,
			String p_rue_s,
			String p_cp_s,
			String p_ville_s,
			String p_pays_s,
			String p_web,
			String p_commentaire
		)
	{
		
		udfa.updateContact(p_code, p_type, p_nom, p_prenom, p_rue, p_cp, p_ville, p_pays, p_jour, p_mois, p_annee, p_email_pers, p_email_prof, p_fixe, p_portable, p_professionnel, p_intitule, p_raison_sociale, p_rue_s, p_cp_s, p_ville_s, p_pays_s, p_web, p_commentaire);
		udb.saveContacts(udfa.getContacts());
		return false;
	}
	
	//type == 0 -> tous les contacts, 1 -> seulement les professionnels, autre -> seulement les privs,
	public void printContact(int type) throws XMLDBException
	{
		if(type == 0)
			udfa.analyseContacts();
		else if(type == 1)
			udfa.afficheContactProfessionnel();
		else
			udfa.afficheContactPrive();
	}
	
	public void printContactCode(String p_code)
	{
		udfa.afficheContactByCode(p_code);
	}
	
	public void recherche(String p_nom, String p_prenom, String p_ville, String p_pays, int type) throws XMLDBException
	{
		this.udfa.recherche(p_nom, p_prenom, p_ville, p_pays, type);
	}
	
	public boolean isEventDay(String p_jour, String p_mois, String p_annee) throws XMLDBException{
		return this.udfa.evenementByDateBoolean(p_jour, p_mois, p_annee);
	}
	
	public boolean addEvenement(
			String p_type,
			String p_sujet,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_heure,
			String p_duree,
			String p_endroit,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_salle,
			String p_commentaire
		)
	{
		udfa.addEvenement(udfa.createEvenement("E"+this.code,p_type, p_sujet, p_jour, p_mois, p_annee, p_heure, p_duree, p_endroit, p_rue, p_cp, p_ville, p_pays, p_salle, p_commentaire));
		this.code++;
		udb.saveCalendrier(udfa.getCalendrier());
		return true;
	}
	
	public boolean removeEvenement(String code)
	{
		udfa.removeEvenement(code);
		udb.saveCalendrier(udfa.getCalendrier());
		return false;
	}
	
	public boolean updateEvenement(
			String p_code,
			String p_type,
			String p_sujet,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_heure,
			String p_duree,
			String p_endroit,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_salle,
			String p_commentaire
		)
	{
		udfa.updateEvenement(p_code,p_type, p_sujet, p_jour, p_mois, p_annee, p_heure, p_duree, p_endroit, p_rue, p_cp, p_ville, p_pays, p_salle, p_commentaire);
		udb.saveCalendrier(udfa.getCalendrier());
		return true;
	}

	public void printEvenement()// mettre en jaune dans le calendrier une date o on a un vnement
	{
		this.udfa.analyseCalendrier();
	}	
	
	public void printEvenementDate(String p_jour, String p_mois, String p_annee) throws XMLDBException
	{
		udfa.evenementByDate(p_jour, p_mois, p_annee);
	}
	
}
