import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;
import java.util.HashMap;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.SwingConstants;
import javax.swing.UIManager;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumn;

import org.xmldb.api.base.XMLDBException;

public class Interface implements ActionListener {

	private JFrame framePrincipale;
	private AjoutContact ajoutContact;

	private ModifierContact modifierContact;
	private ModifierEvenement modifierEvenement;

	private JTabbedPane onglets;

	//Onglet contacts
	private JPanel panelContacts;

	private JPanel panelAgenda;

	private JPanel filtres;
	private JLabel nom;
	private JLabel prenom;
	private JLabel ville;
	private JLabel pays;
	private JTextField saisieNom;
	private JTextField saisiePrenom;
	private JTextField saisieVille;
	private JTextField saisiePays;

	private JRadioButton prive=new JRadioButton("Priv",true);
	private JRadioButton professionnel= new JRadioButton("Professionnel");

	private JPanel contacts;
	private JTable tableauContacts;

	private JButton valider,reinit;
	
	//Onglet agenda
	public static JTable horaires;
	public static DefaultTableModel modele;

	//Menu
	private JMenu contact;
	private JMenuBar menuBar;
	private JMenuItem ajouter;
	private JMenuItem modifier;
	private JMenuItem supprimer;
	private JMenu programme;
	private JMenuItem informations;
	private JMenuItem quitter;
	private JMenu evenement;
	private JMenuItem ajouterEvenement;
	private JMenuItem modifEvenement;
	private JMenuItem supprimerEvenement;

	//Connexion db
	public static DatabaseExistLink database;
	
	static DefaultTableModel modeleTable;
	static int compteurLignes=0;
	static HashMap<String,Contact> stockContacts = new HashMap<String,Contact>() ;
	static ArrayList<String> correspondanceIndiceCode = new ArrayList<String>();

	public Interface() {
		try {
			Interface.database = new DatabaseExistLink();
		} catch (ClassNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InstantiationException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (XMLDBException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		this.framePrincipale=new JFrame("Agenda");
		this.framePrincipale.setSize(1000,600);

		this.initContacts();
		this.initAgenda();
		this.initMenu();
		this.initOnglets();
		this.framePrincipale.getContentPane().add(this.onglets);
		this.framePrincipale.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		//this.framePrincipale.pack();
		this.framePrincipale.setVisible(true);
	}

	public void initContacts() {
		this.panelContacts=new JPanel(new BorderLayout());
		this.initFiltres();
		this.initTableauContacts();
	}

	public void initOnglets(){
		this.onglets = new JTabbedPane();
		this.onglets.add("Contacts",this.panelContacts);
		this.onglets.add("Agenda",this.panelAgenda);

	}

	public void initMenu(){
		this.contact = new JMenu("Contact");
		this.menuBar = new JMenuBar();
		this.ajouter = new JMenuItem("Ajouter");
		this.ajouter.addActionListener(this);
		this.modifier = new JMenuItem("Modifier");
		this.modifier.addActionListener(this);
		this.supprimer = new JMenuItem("Supprimer");
		this.supprimer.addActionListener(this);

		this.contact.add(ajouter);
		this.contact.add(modifier);
		this.contact.add(supprimer);

		this.programme = new JMenu("Programme");
		this.informations = new JMenuItem("Informations");
		this.informations.addActionListener(this);
		this.quitter = new JMenuItem("Quitter");
		this.quitter.addActionListener(this);
		this.programme.add(informations);
		this.programme.add(quitter);

		this.menuBar.add(programme);
		this.menuBar.add(contact);
		this.framePrincipale.setJMenuBar(menuBar);
		
		this.evenement=new JMenu("Evenement");
		this.ajouterEvenement=new JMenuItem("Ajouter");
		this.ajouterEvenement.addActionListener(this);
		this.modifEvenement=new JMenuItem("Modifier");
		this.modifEvenement.addActionListener(this);
		this.supprimerEvenement=new JMenuItem("Supprimer");
		this.supprimerEvenement.addActionListener(this);
		this.evenement.add(this.ajouterEvenement);
		this.evenement.add(this.modifEvenement);
		this.evenement.add(this.supprimerEvenement);
		this.menuBar.add(this.evenement);
	}

	public void initAgenda(){
		String[] headersRow = {"00:00","00:30","01:00","01:30","02:00","02:30","03:00","03:30","04:00","04:30","05:00","05:30","06:00",
				"06:30","07:00","07:30","08:00","08:30","09:00","09:30","10:00","10:30","11:00","11:30","12:00","12:30","13:00","13:30",
				"14:00","14:30","15:00","15:30","16:00","16:30","17:00","17:30","18:00","18:30","19:00","19:30","20:00","20:30","21:00",
				"21:30","22:00","22:30","23:00","23:30"};
		//Cration du JPanel
		this.panelAgenda=new JPanel(new GridLayout());
		//On cr le calendrier
		this.panelAgenda.add(new Calendrier());

		//On passe a la table des horaires  droite
		this.modele = new DefaultTableModel(){
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;

			public boolean isCellEditable(int rowIndex, int mColIndex){
				if (mColIndex == 1) {
					return true;
				}
				return false;
			}
		};
		Interface.horaires = new JTable(modele);
		JScrollPane sp = new JScrollPane(horaires);

		//On ajoute les headers et les nb de colonnes/lignes
		String[] headers = {"Horaires", "Intitul"}; //All headers
		for (int i=0; i<2; i++){
			modele.addColumn(headers[i]);
		}

		/*for (int i=0; i<2; i++){
        	modele.addColumn(headers[i]);
        }*/

		modele.setColumnCount(2);
		modele.setRowCount(48);

		//On aligne le texte au milieu pour la colonne des horaires
		DefaultTableCellRenderer renderer = new DefaultTableCellRenderer();
		renderer.setHorizontalAlignment(SwingConstants.CENTER);
		TableColumn col1 = horaires.getColumnModel().getColumn(0);
		col1.setCellRenderer(renderer);

		for (int i=0; i<48; i++) {
			modele.setValueAt(headersRow[i], i, 0);
			//modele.s
		}


		//On ajuste la taille de la premiere colonne (horaires)
		TableColumn column = horaires.getColumnModel().getColumn(0);
		column.setMaxWidth(100);
		column.setResizable(false);

		//On ajoute enfin la table des horaires au JScrollPane
		this.panelAgenda.add(sp);
        //Calendrier.ajoutLigneEvenement("1","Coiffeur", "02", "06", "2009","18:00", "1", "Chez le coiffeur", "rue gustave simon", "54000","NANCY", "FRANCE", "3", "pouet");

	}

	public void initTableauContacts() {
		this.contacts=new JPanel(new BorderLayout());
		Dimension d = new Dimension(800,500);
		this.contacts.setPreferredSize(d);

		modeleTable = new DefaultTableModel(){
			/**
			 * 
			 */
			private static final long serialVersionUID = 1L;
			public void removeRow(int ligne){
				super.removeRow(ligne);
			}
			public boolean isCellEditable(int rowIndex, int mColIndex){
				return false;};
		};
		this.tableauContacts = new JTable(modeleTable);
		this.tableauContacts.getSelectionModel().addListSelectionListener(new ListSelectionListener() {

			@Override
			public void valueChanged(ListSelectionEvent arg0) {
				System.out.println("POUET!");

			}
		});

		String[] headers = {"Nom", "Prenom", "Tl. fixe", "Tl. portable", "Tl. pro"}; //All headers
		for (int i=0; i<5; i++){
			modeleTable.addColumn(headers[i]);
		}
		modeleTable.setColumnCount(5);
		modeleTable.setRowCount(35);


		JScrollPane sp = new JScrollPane(this.tableauContacts);
		this.contacts.add(sp);
		this.panelContacts.add(this.contacts,BorderLayout.CENTER);
		try {
			Interface.database.recherche("", "", "", "", 0);
		} catch (XMLDBException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*remplirTableauContacts("1","Priv","Dupont", "Jean", "3 rue gustave simon","54000","NANCY",
				"France","30","07","1985","francoisbailly@hotmail.fr","dukable@hotmail.com","0323232323",
				"0672425286","0323236598","Bailly Corporation","tralala","42th avenue","3443","New York","USA","www.truc.com","commentaire");
		remplirTableauContacts("2","Priv","Zzzz","Zzzz","","","","","","","","","","","","","","","","","","","","");*/
	}

	public void initFiltres() {
		this.filtres=new JPanel();
		this.filtres.setLayout(null);
		Dimension d = new Dimension(200,100);
		this.filtres.setPreferredSize(d);
		this.nom=new JLabel("Nom: ");
		this.nom.setBounds(1,1,80,20);

		this.prenom=new JLabel("Prenom: ");
		this.prenom.setBounds(1,22,80,20);

		this.ville=new JLabel("Ville: ");
		this.ville.setBounds(1,44,80,20);

		this.pays=new JLabel("Pays: ");
		this.pays.setBounds(1,66,80,20);

		this.saisieNom=new JTextField();
		this.saisieNom.setBounds(60,1,125,20);

		this.saisiePrenom=new JTextField();
		this.saisiePrenom.setBounds(60,22,125,20);

		this.saisieVille=new JTextField();
		this.saisieVille.setBounds(60,44,125,20);

		this.saisiePays=new JTextField();
		this.saisiePays.setBounds(60,66,125,20);

		this.prive.setBounds(0,88,60,20);
		this.professionnel.setBounds(60,88,125,20);
		
		this.filtres.add(this.nom);
		this.filtres.add(this.saisieNom);
		this.filtres.add(this.prenom);
		this.filtres.add(this.saisiePrenom);
		this.filtres.add(this.ville);
		this.filtres.add(this.saisieVille);
		this.filtres.add(this.pays);
		this.filtres.add(this.saisiePays);
		
		this.filtres.add(prive);
		this.filtres.add(professionnel);

		this.valider = new JButton("Valider");
		this.valider.addActionListener(this);
		valider.setBounds(5, 120, 80, 25);

		this.reinit = new JButton("Rinitialiser");
		this.reinit.addActionListener(this);
		reinit.setBounds(90, 120, 105, 25);

		this.filtres.add(valider);
		this.filtres.add(reinit);

		this.panelContacts.add(this.filtres,BorderLayout.EAST);
	}

	public static void remplirTableauContacts(String p_code, String p_type, String p_nom, String p_prenom,
			String p_rue, String p_cp, String p_ville, String p_pays,
			String p_jour, String p_mois, String p_annee, String p_email_pers,
			String p_email_prof, String p_fixe, String p_portable,
			String p_professionnel, String p_intitule, String p_raison_sociale,
			String p_rue_s, String p_cp_s, String p_ville_s, String p_pays_s,
			String p_web, String p_commentaire) {

		/*Contact test = new Contact("1","Priv","Dupont", "Jean", "3 rue gustave simon","54000","NANCY",
				"France","30","07","1985","francoisbailly@hotmail.fr","dukable@hotmail.com","0323232323",
				"0672425286","0323236598","Bailly Corporation","tralala","42th avenue","3443","New York","USA","www.truc.com","commentaire");*/

		Contact c = new Contact(p_code, p_type, p_nom, p_prenom, p_rue, p_cp, p_ville, p_pays,
				p_jour, p_mois, p_annee, p_email_pers, p_email_prof, p_fixe, p_portable, p_professionnel, 
				p_intitule, p_raison_sociale, p_rue_s, p_cp_s, p_ville_s, p_pays_s, p_web, p_commentaire);

		stockContacts.put(p_code, c);
		correspondanceIndiceCode.add(p_code);

		modeleTable.setValueAt(c.getP_nom(), compteurLignes, 0);
		modeleTable.setValueAt(c.getP_prenom(), compteurLignes, 1);
		modeleTable.setValueAt(c.getP_fixe(), compteurLignes, 2);
		modeleTable.setValueAt(c.getP_portable(), compteurLignes, 3);
		modeleTable.setValueAt(c.getP_professionnel(), compteurLignes, 4);
		compteurLignes++;

	}

	//Faire des listener en faisant un implements TableModelListener
	//Du coup redefinir la mthode tableChanged, voir section Listening for Data Changes  dans la doc de sun
	//a permettrais, ds qu'une donne change dans la table de la mettre  jour ventuellement



	public static void main (String []args){
		Interface vue = new Interface();

	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == this.valider) {
			int nbLignes=Interface.modeleTable.getRowCount();
			Interface.modeleTable.setRowCount(0);
			compteurLignes=0;
			Interface.modeleTable.setRowCount(nbLignes);
			try {
				int nature;
				if ( this.prive.isSelected() && this.professionnel.isSelected() || !this.prive.isSelected() && !this.professionnel.isSelected()){
					nature = 0; 
				}else{
					if (this.prive.isSelected()){
						nature = 1;
					}else{
						nature = 2;
					}
				}
				Interface.database.recherche(this.saisieNom.getText(), this.saisiePrenom.getText(), this.saisieVille.getText(), this.saisiePays.getText(), nature);
			} catch (XMLDBException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
		}
		
		if (e.getSource() == this.reinit) {
			System.out.println("reinit!");
			this.saisieNom.setText("");
			this.saisiePrenom.setText("");
			this.saisieVille.setText("");
			this.saisiePays.setText("");
		}
		if (e.getSource() == this.quitter){
			System.out.println("quit!");
			database.closeDatabase();
			this.framePrincipale.dispose();
		}
		if (e.getSource() == this.informations) {
			JOptionPane.showMessageDialog(this.framePrincipale, "Agenda XML/Java\nMiage de Nancy");
		}
		if (e.getSource() == this.ajouter) {
			this.ajoutContact = new AjoutContact();
			this.ajoutContact.pack();
			this.ajoutContact.setVisible(true);
		}
		if (e.getSource() == this.supprimer) {
			//On appelle la fonction de suppression en passant le code en parametre, qu'on rcupre, grace  l'indice de la ligne
			int indice=this.tableauContacts.getSelectedRow();
			modeleTable.removeRow(indice);
			System.out.println("On supprile la ligne  l'indice "+indice);
			//FONCTION CHRISTOPHE
			String indiceCorrespondant = correspondanceIndiceCode.get(indice);
			System.out.println("Le code correspondant  l'indice de la ligne est:"+indiceCorrespondant);
			Contact c = stockContacts.get(indiceCorrespondant);
			String test = c.getP_code();
			System.out.println("On a recup le contact, son code est:"+test);
			Interface.stockContacts.remove(test);
			Interface.correspondanceIndiceCode.remove(indice);
			Interface.database.removeContact(test);
			System.out.println("francois listener:"+test);

		}
		if (e.getSource() == this.modifier) {
			//On appelle la fonction de modification en passant le code en parametre, et toutes les donnes
			String indiceCorrespondant = correspondanceIndiceCode.get(this.tableauContacts.getSelectedRow());
			Contact c = stockContacts.get(indiceCorrespondant);
			this.modifierContact = new ModifierContact(c);
			this.modifierContact.pack();
			this.modifierContact.setVisible(true);
		}
		if (e.getSource() == this.ajouterEvenement) {
			AjoutEvenement ajout = new AjoutEvenement();
			ajout.pack();
			ajout.setVisible(true);
		}
		if (e.getSource() == this.modifEvenement) {
			try {
				int selectedRow=Interface.horaires.getSelectedRow();
				String indiceCorrespondant = Calendrier.correspondanceIndiceCode.get(""+selectedRow);
				Evenement event = Calendrier.stockEvenements.get(""+indiceCorrespondant);	
				this.modifierEvenement = new ModifierEvenement(event);
				this.modifierEvenement.pack();
				this.modifierEvenement.setVisible(true);
				Interface.database.printEvenementDate(event.getJour(),event.getMois(),event.getAnnee());
			}catch (XMLDBException e1) {
				e1.printStackTrace();
			}catch(NullPointerException e1){
				System.out.println("Aucun evenement selectionn.");
			}
		}	
		if (e.getSource() == this.supprimerEvenement) {
			//On appelle la fonction de suppression en passant le code en parametre, qu'on rcupre, grace  l'indice de la ligne
			int indice=Interface.horaires.getSelectedRow();
			Interface.modele.setValueAt(null,indice,1);
			String indiceCorrespondant = Calendrier.correspondanceIndiceCode.get(""+indice);
			Interface.database.removeEvenement(indiceCorrespondant);
		}
	}

	public static int getCompteurLignes() {
		return compteurLignes;
	}

	public static void setCompteurLignes(int compteurLignes) {
		Interface.compteurLignes = compteurLignes;
	}	
}
