import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.xmldb.api.base.XMLDBException;


public class ModifierContact extends JFrame implements ActionListener {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	
	Contact contact;
	//Frame ajout contact
	private ButtonGroup appartenance=new ButtonGroup();
	private JRadioButton prive=new JRadioButton("Priv");
	private JRadioButton professionnel= new JRadioButton("Professionnel");
	
	private JLabel nomAjout;
	private JLabel prenomAjout;
	private JLabel adresse;
	private JLabel adresseVide;
	private JLabel rueAjout;
	private JLabel cpAjout;
	private JLabel villeAjout;
	private JLabel paysAjout;
	private JLabel dateNaissance;
	private JLabel dateNaissanceVide;
	private JLabel jourAjout;
	private JLabel moisAjout;
	private JLabel anneeAjout;
	private JLabel email;
	private JLabel emailVide;
	private JLabel mailPrive;
	private JLabel mailPro;
	private JLabel telephone;
	private JLabel telephoneVide;
	private JLabel telFixe;
	private JLabel telPro;
	private JLabel telPortable;
	private JLabel activite;
	private JLabel activiteVide;
	private JLabel intitule;
	private JLabel societe;
	private JLabel societeVide;
	private JLabel raisonSociale;
	private JLabel rueSociete;
	private JLabel cpSociete;
	private JLabel villeSociete;
	private JLabel paysSociete;
	private JLabel web;
	private JLabel commentaire;
	
	private JTextField tfNom;
	private JTextField tfPrenom;
	private JTextField tfRue;
	private JTextField tfCp;
	private JTextField tfVille;
	private JTextField tfPays;
	private JComboBox tfJour;
	private JComboBox tfMois;
	private JComboBox tfAnnee;
	private JTextField tfMailPrive;
	private JTextField tfMailPro;
	private JTextField tfTelFix;
	private JTextField tfTelPro;
	private JTextField tfTelPortable;
	private JTextField tfIntitule;
	private JTextField tfRaisonSociale;
	private JTextField tfRueSociete;
	private JTextField tfCpSociete;
	private JTextField tfVilleSociete;
	private JTextField tfPaysSociete;
	private JTextField tfWeb;
	private JTextField tfCommentaire;
	
	private JButton validerAjout;
	private JButton reinitAjout;
	
	public ModifierContact(Contact c){
		this.contact=c;
		this.setTitle("Modifier un contact");
		this.setLayout(new GridLayout(30,2));
		
		if (c.getP_type().compareTo("prive")==0){
			this.prive.setSelected(true);
		}else{
			this.professionnel.setSelected(true);
		}
		
		this.nomAjout = new JLabel("Nom*:");
		this.tfNom = new JTextField();
		this.tfNom.setText(c.getP_nom());
		
		this.prenomAjout = new JLabel("Prenom*:");
		this.tfPrenom = new JTextField();
		this.tfPrenom.setText(c.getP_prenom());
		
		this.adresse = new JLabel("Adresse");
		this.adresseVide = new JLabel("");
		
		this.rueAjout = new JLabel("Rue:");
		this.tfRue = new JTextField();
		this.tfRue.setText(c.getP_rue());
		
		this.cpAjout = new JLabel("Code postal:");
		this.tfCp = new JTextField();
		this.tfCp.setText(c.getP_cp());
		
		this.villeAjout = new JLabel("Ville:");
		this.tfVille = new JTextField();
		this.tfVille.setText(c.getP_ville());
		
		this.paysAjout = new JLabel("pays:");
		this.tfPays = new JTextField();
		this.tfPays.setText(c.getP_pays());
		
		this.dateNaissance = new JLabel("Date de naissance");
		this.dateNaissanceVide = new JLabel("");
		
		this.jourAjout = new JLabel("Jour:");
		this.tfJour = new JComboBox();
		for (int i = 1 ; i <= 31 ; i++){
			this.tfJour.addItem(String.valueOf(i));
		}
		this.tfJour.setSelectedItem(c.getP_jour());
		
		this.moisAjout = new JLabel("Mois:");
		this.tfMois = new JComboBox();
		for (int i = 1 ; i <= 12 ; i++){
			this.tfMois.addItem(String.valueOf(i));
		}
		this.tfMois.setSelectedItem(c.getP_mois());
		
		this.anneeAjout = new JLabel("Anne:");
		this.tfAnnee = new JComboBox();
		for (int i = 1900 ; i <= 2009 ; i++){
			this.tfAnnee.addItem(String.valueOf(i));
		}
		this.tfAnnee.setSelectedItem(c.getP_annee());
		
		this.email = new JLabel("E-mail");
		this.emailVide = new JLabel("");
		
		this.mailPrive = new JLabel("Mail priv:");
		this.tfMailPrive = new JTextField();
		this.tfMailPrive.setText(c.getP_email_pers());
		
		this.mailPro = new JLabel("Mail pro:");
		this.tfMailPro = new JTextField();
		this.tfMailPro.setText(c.getP_email_prof());
		
		this.telephone = new JLabel("Telephones");
		this.telephoneVide = new JLabel("");
		
		this.telFixe = new JLabel("Telephone fixe:");
		this.tfTelFix = new JTextField();
		this.tfTelFix.setText(c.getP_fixe());
		
		this.telPro = new JLabel("Telephone pro");
		this.tfTelPro = new JTextField();
		this.tfTelPro.setText(c.getP_professionnel());
		
		this.telPortable = new JLabel("Telephone portable");
		this.tfTelPortable = new JTextField();
		this.tfTelPortable.setText(c.getP_portable());
		
		this.activite = new JLabel("Activite");
		this.activiteVide = new JLabel("");
		
		this.intitule = new JLabel("Intitul:");
		this.tfIntitule = new JTextField();
		this.tfIntitule.setText(c.getP_intitule());
		
		this.societe = new JLabel("Socit");
		this.societeVide = new JLabel("");
		
		this.raisonSociale = new JLabel("Raison Sociale:");
		this.tfRaisonSociale = new JTextField();
		this.tfRaisonSociale.setText(c.getP_raison_sociale());
		
		this.rueSociete = new JLabel("Adresse");
		this.tfRueSociete = new JTextField("");
		this.tfRueSociete.setText(c.getP_rue_s());
		
		this.cpSociete = new JLabel("Code postal:");
		this.tfCpSociete = new JTextField("");
		this.tfCpSociete.setText(c.getP_cp_s());
		
		this.villeSociete = new JLabel("Ville:");
		this.tfVilleSociete = new JTextField();
		this.tfVilleSociete.setText(c.getP_ville_s());
		
		this.paysSociete = new JLabel("Pays:");
		this.tfPaysSociete = new JTextField();
		this.tfPaysSociete.setText(c.getP_pays_s());
		
		this.web = new JLabel("Site web:");
		this.tfWeb = new JTextField();
		this.tfWeb.setText(c.getP_web());
		
		this.commentaire = new JLabel("Commentaire:");
		this.tfCommentaire = new JTextField();
		this.tfCommentaire.setText(c.getP_commentaire());
		
		this.appartenance.add(this.prive);
		this.appartenance.add(this.professionnel);
		
		this.add(prive);
		this.add(professionnel);
		
		this.add(nomAjout);
		this.add(tfNom);
		this.add(prenomAjout);
		this.add(tfPrenom);
		this.add(adresse);
		this.add(adresseVide);
		this.add(rueAjout);
		this.add(tfRue);
		this.add(cpAjout);
		this.add(tfCp);
		this.add(villeAjout);
		this.add(tfVille);
		this.add(paysAjout);
		this.add(tfPays);
		this.add(dateNaissance);
		this.add(dateNaissanceVide);
		this.add(jourAjout);
		this.add(tfJour);
		this.add(moisAjout);
		this.add(tfMois);
		this.add(anneeAjout);
		this.add(tfAnnee);
		this.add(email);
		this.add(emailVide);
		this.add(mailPrive);
		this.add(tfMailPrive);
		this.add(mailPro);
		this.add(tfMailPro);
		this.add(telephone);
		this.add(telephoneVide);
		this.add(telFixe);
		this.add(tfTelFix);
		this.add(telPro);
		this.add(tfTelPro);
		this.add(telPortable);
		this.add(tfTelPortable);
		this.add(activite);
		this.add(activiteVide);
		this.add(intitule);
		this.add(tfIntitule);
		this.add(societe);
		this.add(societeVide);
		this.add(raisonSociale);
		this.add(tfRaisonSociale);
		this.add(rueSociete);
		this.add(tfRueSociete);
		this.add(cpSociete);
		this.add(tfCpSociete);
		this.add(villeSociete);
		this.add(tfVilleSociete);
		this.add(paysSociete);
		this.add(tfPaysSociete);
		this.add(web);
		this.add(tfWeb);
		this.add(commentaire);
		this.add(tfCommentaire);
		
		this.validerAjout=new JButton("Valider");
		this.validerAjout.addActionListener(this);
		this.add(this.validerAjout);
		
		this.reinitAjout=new JButton("Reinitialiser");
		this.reinitAjout.addActionListener(this);
		this.add(this.reinitAjout);
	}
	
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == validerAjout) {
			if(this.tfNom.getText().compareTo("")==0 || this.tfNom == null || this.tfPrenom.getText().compareTo("")==0 || this.tfPrenom == null){
				JOptionPane.showMessageDialog(this, "Les champs noms et prenoms doivent tre imprativement renseigns.");
			}else{
				//Fonction qui permet l'ajout
				String nature;
				if (this.prive.isSelected()){
					nature="prive";
				}else{
					nature="professionnel";
				}
				Interface.database.updateContact(this.contact.getP_code(), nature, this.tfNom.getText(), this.tfPrenom.getText(), this.tfRue.getText(), this.tfCp.getText(), this.tfVille.getText(), this.tfPays.getText(), this.tfJour.getSelectedItem().toString(), this.tfMois.getSelectedItem().toString(), this.tfAnnee.getSelectedItem().toString(), this.tfMailPrive.getText(), this.tfMailPro.getText(), this.tfTelFix.getText(), this.tfTelPortable.getText(), this.tfTelPro.getText(), this.tfIntitule.getText(), this.tfRaisonSociale.getText(), this.tfRueSociete.getText(), this.tfCpSociete.getText(), this.tfVilleSociete.getText(), this.tfPaysSociete.getText(), this.tfWeb.getText(), this.tfCommentaire.getText());
			}
			int nbLignes=Interface.modeleTable.getRowCount();
			Interface.modeleTable.setRowCount(0);
			Interface.compteurLignes=0;
			/*A FAIRE:
			 * Vider la JTable proprement
			 */
			Interface.modeleTable.setRowCount(nbLignes);
			try {
				Interface.database.recherche("", "", "", "", 0);
			} catch (XMLDBException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			this.dispose();
		}
		if (e.getSource() == reinitAjout) {
			this.tfNom.setText("");
			this.tfPrenom.setText("");
			this.tfRue.setText("");
			this.tfCp.setText("");
			this.tfVille.setText("");
			this.tfPays.setText("");
			this.tfJour.setSelectedIndex(-1);
			this.tfMois.setSelectedIndex(-1);
			this.tfAnnee.setSelectedIndex(-1);
			this.tfMailPrive.setText("");
			this.tfMailPro.setText("");
			this.tfTelFix.setText("");
			this.tfTelPro.setText("");
			this.tfTelPortable.setText("");
			this.tfIntitule.setText("");
			this.tfRaisonSociale.setText("");
			this.tfWeb.setText("");
			this.tfCommentaire.setText("");
		}
		
	}
}
