import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.JTextField;

import org.xmldb.api.base.XMLDBException;

public class ModifierEvenement extends JFrame implements ActionListener {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	Evenement event;
	private ButtonGroup appartenance=new ButtonGroup();
	private JRadioButton prive=new JRadioButton("Priv");
	private JRadioButton professionnel= new JRadioButton("Professionnel");
	private JLabel sujet = new JLabel("Sujet:");
	private JLabel jour = new JLabel("Jour:");
	private JLabel mois = new JLabel("Mois:");
	private JLabel annee = new JLabel("Annee:");
	private JLabel heure = new JLabel("Heure:");
	private JLabel duree = new JLabel("Dure:");
	private JLabel endroit = new JLabel("Endroit:");
	private JLabel rue = new JLabel("Rue:");
	private JLabel cp = new JLabel("Code Postal:");
	private JLabel ville = new JLabel("Ville:");
	private JLabel pays = new JLabel("Pays:");
	private JLabel salle = new JLabel("Salle:");
	private JLabel commentaire = new JLabel("Commentaire:");

	private JTextField tfSujet=new JTextField();
	private JComboBox tfJour=new JComboBox();
	private JComboBox tfMois=new JComboBox();
	private JComboBox tfAnnee=new JComboBox();
	private JComboBox tfHeure=new JComboBox();
	private JTextField tfDuree=new JTextField();
	private JTextField tfEndroit=new JTextField();
	private JTextField tfRue=new JTextField();
	private JTextField tfCp=new JTextField();
	private JTextField tfVille=new JTextField();
	private JTextField tfPays=new JTextField();
	private JTextField tfSalle=new JTextField();
	private JTextField tfCommentaire=new JTextField();

	private JButton validerAjout;
	private JButton reinitAjout;

	public ModifierEvenement(Evenement e){
		try {
			this.setTitle("Ajout nouveau evenement");
			this.setLayout(new GridLayout(15,2));

			this.event=e;

			this.appartenance.add(this.prive);
			this.appartenance.add(this.professionnel);
			this.add(prive);
			this.add(professionnel);

			if (event.getType().compareTo("prive")==0){
				this.prive.setSelected(true);
			}else{
				this.professionnel.setSelected(true);
			}

			for (int i = 1 ; i <= 31 ; i++){
				this.tfJour.addItem(String.valueOf(i));
			}
			for (int i = 1 ; i <= 12 ; i++){
				this.tfMois.addItem(String.valueOf(i));
			}
			for (int i = 2009 ; i <= 2020 ; i++){
				this.tfAnnee.addItem(String.valueOf(i));
			}

			this.tfHeure.addItem("00:00");
			this.tfHeure.addItem("00:30");
			this.tfHeure.addItem("01:00");
			this.tfHeure.addItem("01:30");
			this.tfHeure.addItem("02:00");
			this.tfHeure.addItem("02:30");
			this.tfHeure.addItem("03:00");
			this.tfHeure.addItem("03:30");
			this.tfHeure.addItem("04:00");
			this.tfHeure.addItem("04:30");
			this.tfHeure.addItem("05:00");
			this.tfHeure.addItem("05:30");
			this.tfHeure.addItem("06:00");
			this.tfHeure.addItem("06:30");
			this.tfHeure.addItem("07:00");
			this.tfHeure.addItem("07:30");
			this.tfHeure.addItem("08:00");
			this.tfHeure.addItem("08:00");
			this.tfHeure.addItem("08:30");
			this.tfHeure.addItem("09:00");
			this.tfHeure.addItem("09:30");
			this.tfHeure.addItem("10:00");
			this.tfHeure.addItem("10:30");
			this.tfHeure.addItem("11:00");
			this.tfHeure.addItem("11:30");
			this.tfHeure.addItem("12:00");
			this.tfHeure.addItem("12:30");
			this.tfHeure.addItem("13:00");
			this.tfHeure.addItem("13:30");
			this.tfHeure.addItem("14:00");
			this.tfHeure.addItem("14:30");
			this.tfHeure.addItem("15:00");
			this.tfHeure.addItem("15:30");
			this.tfHeure.addItem("16:00");
			this.tfHeure.addItem("16:30");
			this.tfHeure.addItem("17:00");
			this.tfHeure.addItem("17:30");
			this.tfHeure.addItem("18:00");
			this.tfHeure.addItem("18:30");
			this.tfHeure.addItem("19:00");
			this.tfHeure.addItem("19:30");
			this.tfHeure.addItem("20:00");
			this.tfHeure.addItem("20:30");
			this.tfHeure.addItem("21:00");
			this.tfHeure.addItem("21:30");
			this.tfHeure.addItem("22:00");
			this.tfHeure.addItem("22:30");
			this.tfHeure.addItem("23:00");
			this.tfHeure.addItem("23:30");
			this.tfHeure.setSelectedItem(event.getHeure());

			this.add(sujet);
			this.tfSujet.setText(this.event.getSujet());
			this.add(tfSujet);
			this.add(jour);

			this.tfJour.setSelectedItem(event.getJour());
			this.add(tfJour);
			this.add(mois);
			this.tfMois.setSelectedItem(event.getMois());
			this.add(tfMois);
			this.add(annee);
			this.tfAnnee.setSelectedItem(event.getAnnee());

			this.add(tfAnnee);
			this.add(heure);
			this.add(tfHeure);
			this.add(duree);
			this.tfDuree.setText(e.getDuree());
			this.add(tfDuree);
			this.add(endroit);
			this.tfEndroit.setText(e.getEndroit());
			this.add(tfEndroit);
			this.add(rue);
			this.tfRue.setText(e.getRue());
			this.add(tfRue);
			this.add(cp);
			this.tfCp.setText(e.getCp());
			this.add(tfCp);
			this.add(ville);
			this.tfVille.setText(e.getVille());
			this.add(tfVille);
			this.add(pays);
			this.tfPays.setText(e.getPays());
			this.add(tfPays);
			this.add(salle);
			this.tfSalle.setText(e.getSalle());
			this.add(tfSalle);
			this.add(commentaire);
			this.tfCommentaire.setText(e.getCommentaire());
			this.add(tfCommentaire);

			this.validerAjout=new JButton("Valider");
			this.validerAjout.addActionListener(this);
			this.add(this.validerAjout);

			this.reinitAjout=new JButton("Reinitialiser");
			this.reinitAjout.addActionListener(this);
			this.add(this.reinitAjout);
		}catch(NullPointerException e1){
			System.out.println("Aucun evenement selectionn.");
		}finally{
			this.dispose();
		}
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource() == validerAjout) {

			if(this.tfSujet.getText().compareTo("")==0 || this.tfSujet == null || this.tfHeure.getSelectedIndex() == - 1 || this.tfJour.getSelectedIndex()==-1 || this.tfMois.getSelectedIndex()==-1 || this.tfAnnee.getSelectedIndex()==-1){
				JOptionPane.showMessageDialog(this, "Les champs Sujet, Jour, Mois, Annee et Heure doivent tre imprativement renseigns.");
			}else{
				//FONCTION CHRISTOPHE AJOUTER UN CONTACT DANS LA BASE
				String nature;
				if (this.prive.isSelected()){
					nature="prive";
				}else{
					nature="professionnel";
				}
				Interface.database.updateEvenement(this.event.getCode(),nature, this.tfSujet.getText(), this.tfJour.getSelectedItem().toString(), this.tfMois.getSelectedItem().toString(), this.tfAnnee.getSelectedItem().toString(), this.tfHeure.getSelectedItem().toString(), this.tfDuree.getText(), this.tfEndroit.getText(), this.tfRue.getText(), this.tfCp.getText(), this.tfVille.getText(), this.tfPays.getText(), this.tfSalle.getText(), this.tfCommentaire.getText());

				for (int i=0; i<46; i++){
					Interface.modele.setValueAt(null, i, 1);
				}
				Calendrier.stockEvenements.clear();
				Calendrier.correspondanceIndiceCode.clear();

				try {
					Interface.database.printEvenementDate(this.tfJour.getSelectedItem().toString(),this.tfMois.getSelectedItem().toString(),this.tfAnnee.getSelectedItem().toString());
				} catch (XMLDBException e2) {
					e2.printStackTrace();
				}
				this.dispose();
			}

		}
		if (e.getSource() == reinitAjout) {
			this.tfSujet.setText("");

			this.tfJour.setSelectedIndex(-1);

			this.tfMois.setSelectedIndex(-1);

			this.tfAnnee.setSelectedIndex(-1);
			this.tfHeure.setSelectedIndex(-1);
			this.tfDuree.setText("");
			this.tfEndroit.setText("");
			this.tfRue.setText("");
			this.tfCp.setText("");
			this.tfVille.setText("");
			this.tfPays.setText("");
			this.tfSalle.setText("");
			this.tfCommentaire.setText("");
		}

	}

}
