

import javax.xml.transform.OutputKeys;
import org.xmldb.api.DatabaseManager;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Database;
import org.xmldb.api.base.XMLDBException;
import org.xmldb.api.modules.XMLResource;

import org.w3c.dom.Document;


public class UseDataBase 
{
	private Collection agenda;
	private XMLResource contacts;
	private XMLResource calendrier;
	
	private final String URI = "xmldb:exist://localhost:8080/exist/xmlrpc";
	
	public UseDataBase() throws ClassNotFoundException, InstantiationException, IllegalAccessException, XMLDBException
	{
		//Initialisation du driver
   	 	String driver = "org.exist.xmldb.DatabaseImpl";
        Class<?> c = Class.forName(driver);
        Database database = (Database) c.newInstance();
        DatabaseManager.registerDatabase(database);
        this.agenda = DatabaseManager.getCollection(URI + "/db/Agenda");
        this.agenda.setProperty(OutputKeys.INDENT,"yes");
        this.contacts = (XMLResource)agenda.getResource("contacts.xml");
        this.calendrier = (XMLResource)agenda.getResource("calendrier.xml");
   	}
	
	public Collection getAgenda()
	{
		return this.agenda;
	}
	
	public void getContentsContacts()
	{
		System.out.println("----------Contenu de la ressource XML Contacts-----------\n");
		try 
		{
			System.out.println(this.contacts.getContent()+"");
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception in method getContentsContacts from class UseDataBase");
			e.printStackTrace();
		}
		System.out.println("\n-----------Fin Contenu de la ressource XML Contacts------------\n");
	}
	
	public void getContentsCalendrier()
	{
		System.out.println("----------Contenu de la ressource XML Calendrier-----------\n");
		try 
		{
			System.out.println(this.calendrier.getContent()+"");
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception in method getContentsCalendrier from class UseDataBase");
			e.printStackTrace();
		}
		System.out.println("\n-----------Fin Contenu de la ressource XML Calendrier------------\n");
	}
	
	public org.w3c.dom.Document getContactsAsDom()
	{
		try 
		{
			return (org.w3c.dom.Document) this.contacts.getContentAsDOM();
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception in method getContactsAsDom from class UseDataBase");
			e.printStackTrace();
		}
		return null;
	}
	
	public org.w3c.dom.Document getCalendrierAsDom()
	{
		try 
		{
			return (org.w3c.dom.Document) this.calendrier.getContentAsDOM();
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception in method getCalendrierAsDom from class UseDataBase");
			e.printStackTrace();
		}
		return null;
	}
	
	public void saveContacts(Document contacts)
	{
   	 	try 
   	 	{
   	 		this.contacts.setContentAsDOM(contacts);
			this.agenda.storeResource(this.contacts);
		}
   	 	catch (XMLDBException e) 
   	 	{
   	 		System.err.println("Exception in method saveContacts from class UseDataBase");
			e.printStackTrace();
		}
	}
	
	public void saveCalendrier(Document calendar)
	{
		try 
		{
			this.calendrier.setContentAsDOM(calendar);
			this.agenda.storeResource(this.calendrier);
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception in method saveCalendrier from class UseDataBase");
			e.printStackTrace();
		}
	}
	
	public void reloadAgenda()
	{
		try 
		{
			this.contacts = (XMLResource)agenda.getResource("contacts.xml");
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception[1] in method reloadAgenda from class UseDataBase");
			e.printStackTrace();
		}
        try 
        {
			this.calendrier = (XMLResource)agenda.getResource("calendrier.xml");
		}
        catch (XMLDBException e) 
        {
        	System.err.println("Exception[2] in method reloadAgenda from class UseDataBase");
			e.printStackTrace();
		}
	}
	
	public void closeAgenda()
	{
		try 
		{
			this.agenda.close();
		}
		catch (XMLDBException e) 
		{
			System.err.println("Exception in method closeAgenda from class UseDataBase");
			e.printStackTrace();
		}
	}
}
