import org.exist.xmldb.XQueryService;
import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;
import org.xmldb.api.base.Collection;
import org.xmldb.api.base.Resource;
import org.xmldb.api.base.ResourceIterator;
import org.xmldb.api.base.ResourceSet;
import org.xmldb.api.base.XMLDBException;

public class UseDomForAgenda
{
	private final String uri1 = "http://www.domaine_general.fr";
	private final String uri2 = "http://www.domaine_activite.fr";
	
	private Collection agenda;
	private Document contacts;
	private Document calendrier;
	
	public UseDomForAgenda(Collection agenda, Document contacts, Document calendrier)
	{
		this.agenda = agenda;
		this.contacts = contacts;
		this.calendrier = calendrier;		
	}
	
	public Document getContacts()
	{
		return this.contacts;
	}
	
	public Document getCalendrier()
	{
		return this.calendrier;
	}
	
	public void addContact(Element contact)
	{
		this.contacts.getDocumentElement().appendChild(contact);
	}
	
	public void addEvenement(Element evenement)
	{
		this.calendrier.getDocumentElement().appendChild(evenement);
	}
	
	public void updateContact(
			String p_code,
			String p_type,
			String p_nom,
			String p_prenom,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_email_pers,
			String p_email_prof,
			String p_fixe,
			String p_portable,
			String p_professionnel,
			String p_intitule,
			String p_raison_sociale,
			String p_rue_s,
			String p_cp_s,
			String p_ville_s,
			String p_pays_s,
			String p_web,
			String p_commentaire)
	{
		//trouver dans init
		//Element e = this.contacts.getElementById(p_code);
		
		Element temp = (Element) this.getContactByCode(p_code);
				
		//parcours du noeud petit  petit -> si p_string != noeud.string => set
		
		if(temp.getAttributeNodeNS(uri1,"type").getNodeValue().compareTo("type")!=0)
			temp.getAttributeNodeNS(uri1,"type").setNodeValue(p_type);
			
		NamedNodeMap nnm;
		
		NodeList nl = null;
		nl = temp.getElementsByTagNameNS(uri1,"nom");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node c:nom");
		else
			if(nl.item(0).getTextContent().compareTo(p_nom)!=0)
				nl.item(0).setTextContent(p_nom);
		
		nl = temp.getElementsByTagNameNS(uri1,"prenom");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node c:prenom");
		else
			if(nl.item(0).getTextContent().compareTo(p_prenom)!=0)
				nl.item(0).setTextContent(p_prenom);
		
		nl = temp.getElementsByTagNameNS(uri1,"rue");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node c:rue");
		else
			if(nl.item(0).getTextContent().compareTo(p_rue)!=0)
				nl.item(0).setTextContent(p_rue);
		
		nl = temp.getElementsByTagNameNS(uri1,"cp");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node c:cp");
		else
			if(nl.item(0).getTextContent().compareTo(p_cp)!=0)
				nl.item(0).setTextContent(p_cp);
		
		nl = temp.getElementsByTagNameNS(uri1,"ville");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node c:ville");
		else
			if(nl.item(0).getTextContent().compareTo(p_ville)!=0)
				nl.item(0).setTextContent(p_ville);
		
		nl = temp.getElementsByTagNameNS(uri1,"pays");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node c:pays");
		else
			if(nl.item(0).getTextContent().compareTo(p_pays)!=0)
				nl.item(0).setTextContent(p_pays);
		
		nl = temp.getElementsByTagNameNS(uri1,"date_naissance");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node date_naissance");
		else
		{
			nnm = nl.item(0).getAttributes();
			int k = 0;
			while(k<nnm.getLength())
			{
				if(nnm.item(k).getNodeName().compareTo("c:annee")==0)
					if(nnm.item(k).getNodeValue().compareTo(p_annee)!=0)
						nnm.item(k).setNodeValue(p_annee);
				if(nnm.item(k).getNodeName().compareTo("c:mois")==0)
					if(nnm.item(k).getNodeValue().compareTo(p_mois)!=0)
						nnm.item(k).setNodeValue(p_mois);
				if(nnm.item(k).getNodeName().compareTo("c:jour")==0)
					if(nnm.item(k).getNodeValue().compareTo(p_jour)!=0)
						nnm.item(k).setNodeValue(p_jour);
				k++;
			}
		}
		
		nl = temp.getElementsByTagNameNS(uri1,"email_prof");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node email_prof");
		else
			if(nl.item(0).getTextContent().compareTo(p_email_prof)!=0)
				nl.item(0).setTextContent(p_email_prof);
		
		nl = temp.getElementsByTagNameNS(uri1,"email_pers");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node email_pers");
		else
			if(nl.item(0).getTextContent().compareTo(p_email_pers)!=0)
				nl.item(0).setTextContent(p_email_pers);

		nl = temp.getElementsByTagNameNS(uri1,"fixe");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node fixe");
		else
			if(nl.item(0).getTextContent().compareTo(p_fixe)!=0)
				nl.item(0).setTextContent(p_fixe);

		nl = temp.getElementsByTagNameNS(uri1,"portable");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node portable");
		else
			if(nl.item(0).getTextContent().compareTo(p_portable)!=0)
				nl.item(0).setTextContent(p_portable);

		nl = temp.getElementsByTagNameNS(uri1,"professionnel");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node professionnel");
		else
			if(nl.item(0).getTextContent().compareTo(p_professionnel)!=0)
				nl.item(0).setTextContent(p_professionnel);

		nl = temp.getElementsByTagNameNS(uri2,"intitule");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node a:intitule");
		else
			if(nl.item(0).getTextContent().compareTo(p_intitule)!=0)
				nl.item(0).setTextContent(p_intitule);

		nl = temp.getElementsByTagNameNS(uri2,"raison_sociale");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node a:raison_sociale");
		else
			if(nl.item(0).getTextContent().compareTo(p_raison_sociale)!=0)
				nl.item(0).setTextContent(p_raison_sociale);
		
		nl = temp.getElementsByTagNameNS(uri2,"rue");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node a:rue");
		else
			if(nl.item(0).getTextContent().compareTo(p_rue_s)!=0)
				nl.item(0).setTextContent(p_rue_s);
		
		nl = temp.getElementsByTagNameNS(uri2,"cp");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node a:cp");
		else
			if(nl.item(0).getTextContent().compareTo(p_cp_s)!=0)
				nl.item(0).setTextContent(p_cp_s);
		
		nl = temp.getElementsByTagNameNS(uri2,"ville");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node a:ville");
		else
			if(nl.item(0).getTextContent().compareTo(p_ville_s)!=0)
				nl.item(0).setTextContent(p_ville_s);
		
		nl = temp.getElementsByTagNameNS(uri2,"pays");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node a:pays");
		else
			if(nl.item(0).getTextContent().compareTo(p_pays_s)!=0)
				nl.item(0).setTextContent(p_pays_s);
		
		nl = temp.getElementsByTagNameNS(uri2,"web");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node nom");
		else
			if(nl.item(0).getTextContent().compareTo(p_web)!=0)
				nl.item(0).setTextContent(p_web);

		nl = temp.getElementsByTagNameNS(uri1,"commentaire");
		if(nl.getLength() != 1)
			System.err.println("Error in extract node nom");
		else
			if(nl.item(0).getTextContent().compareTo(p_commentaire)!=0)
				nl.item(0).setTextContent(p_commentaire);
	}
		
	public void updateEvenement(
			String p_code,
			String p_type,
			String p_sujet,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_heure,
			String p_duree,
			String p_endroit,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_salle,
			String p_commentaire
			)
	{
		Element e = (Element)this.getEvenementByCode(p_code);
		
		if(e.getAttributes().item(1).getNodeValue().compareTo(p_type) != 0)
			e.getAttributes().item(1).setNodeValue(p_type);
		
		if(e.getElementsByTagName("sujet").item(0).getTextContent().compareTo(p_sujet) != 0)
			e.getElementsByTagName("sujet").item(0).setTextContent(p_sujet);
		
		if(e.getElementsByTagName("jour").item(0).getTextContent().compareTo(p_jour) != 0)
			e.getElementsByTagName("jour").item(0).setTextContent(p_jour);
		
		if(e.getElementsByTagName("mois").item(0).getTextContent().compareTo(p_mois) != 0)
			e.getElementsByTagName("mois").item(0).setTextContent(p_mois);
		
		if(e.getElementsByTagName("annee").item(0).getTextContent().compareTo(p_annee) != 0)
			e.getElementsByTagName("annee").item(0).setTextContent(p_annee);
		
		if(e.getElementsByTagName("heure").item(0).getTextContent().compareTo(p_heure) != 0)
			e.getElementsByTagName("heure").item(0).setTextContent(p_heure);
		
		if(e.getElementsByTagName("duree").item(0).getTextContent().compareTo(p_duree) != 0)
			e.getElementsByTagName("duree").item(0).setTextContent(p_duree);
		
		if(e.getElementsByTagName("endroit").item(0).getTextContent().compareTo(p_endroit) != 0)
			e.getElementsByTagName("endroit").item(0).setTextContent(p_endroit);
		
		if(e.getElementsByTagName("rue").item(0).getTextContent().compareTo(p_rue) != 0)
			e.getElementsByTagName("rue").item(0).setTextContent(p_rue);
		
		if(e.getElementsByTagName("cp").item(0).getTextContent().compareTo(p_cp) != 0)
			e.getElementsByTagName("cp").item(0).setTextContent(p_cp);
		
		if(e.getElementsByTagName("ville").item(0).getTextContent().compareTo(p_ville) != 0)
			e.getElementsByTagName("ville").item(0).setTextContent(p_ville);
		
		if(e.getElementsByTagName("pays").item(0).getTextContent().compareTo(p_pays) != 0)
			e.getElementsByTagName("pays").item(0).setTextContent(p_pays);
		
		if(e.getElementsByTagName("salle").item(0).getTextContent().compareTo(p_salle) != 0)
			e.getElementsByTagName("salle").item(0).setTextContent(p_salle);
		
		if(e.getElementsByTagName("commentaire").item(0).getTextContent().compareTo(p_commentaire) != 0)
			e.getElementsByTagName("commentaire").item(0).setTextContent(p_commentaire);
	}
	
	public Node getContactByCode(String code) 
	{	
		 return this.contacts.getElementById(code);
	}

	public Node getEvenementByCode(String code) 
	{	
		return this.calendrier.getElementById(code);
	}
	
	public void removeContact(String code)
	{
		this.contacts.getFirstChild().removeChild(this.getContactByCode(code));
	}
	
	public void removeEvenement(String code)
	{
		this.calendrier.getFirstChild().removeChild(this.getEvenementByCode(code));
	}
	
	public Element createContactWithNS(
			String p_code,
			String p_type,
			String p_nom,
			String p_prenom,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_email_pers,
			String p_email_prof,
			String p_fixe,
			String p_portable,
			String p_professionnel,
			String p_intitule,
			String p_raison_sociale,
			String p_rue_s,
			String p_cp_s,
			String p_ville_s,
			String p_pays_s,
			String p_web,
			String p_commentaire)
	{
		Element contact = this.contacts.createElementNS(uri1,"c:contact");
		contact.setAttribute("xmlns:c", uri1);
		contact.setAttributeNS(uri1,"c:code",p_code);
		contact.setIdAttribute("c:code", true);
		contact.setAttributeNS(uri1,"c:type",p_type);
		
		//cration de la balise nom
		Element nom = this.contacts.createElementNS(uri1,"c:nom");
		Text nom_txt = this.contacts.createTextNode(p_nom);
		nom.appendChild(nom_txt);
		contact.appendChild(nom);
		
		//cration de la balise prenom
		Element prenom = this.contacts.createElementNS(uri1,"c:prenom");
		Text prenom_txt = this.contacts.createTextNode(p_prenom);
		prenom.appendChild(prenom_txt);
		contact.appendChild(prenom);
		
		//cration de la balise adresse
		Element adresse = this.contacts.createElementNS(uri1,"c:adresse");
		Element rue = this.contacts.createElementNS(uri1,"c:rue");
		Text rue_txt = this.contacts.createTextNode(p_rue);
		rue.appendChild(rue_txt);
		adresse.appendChild(rue);
		Element cp = this.contacts.createElementNS(uri1,"c:cp");
		Text cp_txt = this.contacts.createTextNode(p_cp);
		cp.appendChild(cp_txt);
		adresse.appendChild(cp);
		Element ville = this.contacts.createElementNS(uri1,"c:ville");
		Text ville_txt = this.contacts.createTextNode(p_ville);
		ville.appendChild(ville_txt);
		adresse.appendChild(ville);
		Element pays = this.contacts.createElementNS(uri1,"c:pays");
		Text pays_txt = this.contacts.createTextNode(p_pays);
		pays.appendChild(pays_txt);
		adresse.appendChild(pays);
		contact.appendChild(adresse);
		
		//cration de la balise date de naissance
		Element date_naissance = this.contacts.createElementNS(uri1,"c:date_naissance");
		date_naissance.setAttributeNS(uri1,"c:jour", p_jour);
		date_naissance.setAttributeNS(uri1,"c:mois", p_mois);
		date_naissance.setAttributeNS(uri1,"c:annee", p_annee);
		contact.appendChild(date_naissance);
		
		//cration de la balise emails
		Element emails = this.contacts.createElementNS(uri1,"c:emails");
		Element email_pers = this.contacts.createElementNS(uri1,"c:email_pers");
		Text email_pers_txt = this.contacts.createTextNode(p_email_pers);
		email_pers.appendChild(email_pers_txt);
		emails.appendChild(email_pers);
		Element email_prof = this.contacts.createElementNS(uri1,"c:email_prof");
		Text email_prof_txt = this.contacts.createTextNode(p_email_prof);
		email_prof.appendChild(email_prof_txt);
		emails.appendChild(email_prof);
		contact.appendChild(emails);
		
		//cration de la balise telephones
		Element telephones = this.contacts.createElementNS(uri1,"c:telephones");
		Element fixe = this.contacts.createElementNS(uri1,"c:fixe");
		Text fixe_txt = this.contacts.createTextNode(p_fixe);
		fixe.appendChild(fixe_txt);
		telephones.appendChild(fixe);
		Element portable = this.contacts.createElementNS(uri1,"c:portable");
		Text portable_txt = this.contacts.createTextNode(p_portable);
		portable.appendChild(portable_txt);
		telephones.appendChild(portable);
		Element professionnel = this.contacts.createElementNS(uri1,"c:professionnel");
		Text professionnel_txt = this.contacts.createTextNode(p_professionnel);
		professionnel.appendChild(professionnel_txt);
		telephones.appendChild(professionnel);
		contact.appendChild(telephones);
		
		//cration de la balise activite
		Element activite = this.contacts.createElementNS(uri2,"a:activite");
		Element intitule = this.contacts.createElementNS(uri2,"a:intitule");
		Text intitule_txt = this.contacts.createTextNode(p_intitule);
		intitule.appendChild(intitule_txt);
		activite.appendChild(intitule);
		Element societe = this.contacts.createElementNS(uri2,"a:societe");
		Element raison_sociale = this.contacts.createElementNS(uri2,"a:raison_sociale");
		Text raison_sociale_txt = this.contacts.createTextNode(p_raison_sociale);
		raison_sociale.appendChild(raison_sociale_txt);
		societe.appendChild(raison_sociale);
		Element adresse_s = this.contacts.createElementNS(uri2,"a:adresse");
		Element rue_s = this.contacts.createElementNS(uri2,"a:rue");
		Text rue_s_txt = this.contacts.createTextNode(p_rue_s);
		rue_s.appendChild(rue_s_txt);
		adresse_s.appendChild(rue_s);
		Element cp_s = this.contacts.createElementNS(uri2,"a:cp");
		Text cp_s_txt = this.contacts.createTextNode(p_cp_s);
		cp_s.appendChild(cp_s_txt);
		adresse_s.appendChild(cp_s);
		Element ville_s = this.contacts.createElementNS(uri2,"a:ville");
		Text ville_s_txt = this.contacts.createTextNode(p_ville_s);
		ville_s.appendChild(ville_s_txt);
		adresse_s.appendChild(ville_s);
		Element pays_s = this.contacts.createElementNS(uri2,"a:pays");
		Text pays_s_txt = this.contacts.createTextNode(p_pays_s);
		pays_s.appendChild(pays_s_txt);
		adresse_s.appendChild(pays_s);
		societe.appendChild(adresse_s);
		Element web = this.contacts.createElementNS(uri2,"a:web");
		Text web_txt = this.contacts.createTextNode(p_web);
		web.appendChild(web_txt);
		societe.appendChild(web);
		activite.appendChild(societe);
		contact.appendChild(activite);
		
		//cration de la balise commentaire
		Element commentaire = this.contacts.createElementNS(uri1,"c:commentaire");
		Text commentaire_txt = this.contacts.createTextNode(p_commentaire);
		commentaire.appendChild(commentaire_txt);
		contact.appendChild(commentaire);
		
		return contact;
	}
	
	public Element createEvenement(
			String p_code,
			String p_type,
			String p_sujet,
			String p_jour,
			String p_mois,
			String p_annee,
			String p_heure,
			String p_duree,
			String p_endroit,
			String p_rue,
			String p_cp,
			String p_ville,
			String p_pays,
			String p_salle,
			String p_commentaire)
	{
		Element evenement = this.calendrier.createElement("evenement");
		evenement.setAttribute("code",p_code);
		evenement.setIdAttribute("code", true);
		evenement.setAttribute("type",p_type);
		
		//Cration de la balise sujet
		Element sujet = this.calendrier.createElement("sujet");
		Text sujet_txt = this.calendrier.createTextNode(p_sujet);
		sujet.appendChild(sujet_txt);
		evenement.appendChild(sujet);
		
		//Cration de la balise horaire
		Element horaire = this.calendrier.createElement("horaire");
		Element jour = this.calendrier.createElement("jour");
		Text jour_txt = this.calendrier.createTextNode(p_jour);
		jour.appendChild(jour_txt);
		horaire.appendChild(jour);
		Element mois = this.calendrier.createElement("mois");
		Text mois_txt = this.calendrier.createTextNode(p_mois);
		mois.appendChild(mois_txt);
		horaire.appendChild(mois);
		Element annee = this.calendrier.createElement("annee");
		Text annee_txt = this.calendrier.createTextNode(p_annee);
		annee.appendChild(annee_txt);
		horaire.appendChild(annee);
		Element heure = this.calendrier.createElement("heure");
		Text heure_txt = this.calendrier.createTextNode(p_heure);
		heure.appendChild(heure_txt);
		horaire.appendChild(heure);
		Element duree = this.calendrier.createElement("duree");
		Text duree_txt = this.calendrier.createTextNode(p_duree);
		duree.appendChild(duree_txt);
		horaire.appendChild(duree);
		evenement.appendChild(horaire);
		
		//creation de la balise lieu
		Element lieu = this.calendrier.createElement("lieu");
		Element endroit = this.calendrier.createElement("endroit");
		Text endroit_txt = this.calendrier.createTextNode(p_endroit);
		endroit.appendChild(endroit_txt);
		lieu.appendChild(endroit);
		//cration de la balise adresse
		Element adresse = this.calendrier.createElement("adresse");
		Element rue = this.calendrier.createElement("rue");
		Text rue_txt = this.calendrier.createTextNode(p_rue);
		rue.appendChild(rue_txt);
		adresse.appendChild(rue);
		Element cp = this.calendrier.createElement("cp");
		Text cp_txt = this.calendrier.createTextNode(p_cp);
		cp.appendChild(cp_txt);
		adresse.appendChild(cp);
		Element ville = this.calendrier.createElement("ville");
		Text ville_txt = this.calendrier.createTextNode(p_ville);
		ville.appendChild(ville_txt);
		adresse.appendChild(ville);
		Element pays = this.calendrier.createElement("pays");
		Text pays_txt = this.calendrier.createTextNode(p_pays);
		pays.appendChild(pays_txt);
		adresse.appendChild(pays);
		lieu.appendChild(adresse);
		//Fin de cration de la balise adresse
		Element salle = this.calendrier.createElement("salle");
		Text salle_txt = this.calendrier.createTextNode(p_salle);
		salle.appendChild(salle_txt);
		lieu.appendChild(salle);
		evenement.appendChild(lieu);
		
		//creation de la balise commentaire
		Element commentaire = this.calendrier.createElement("commentaire");
		Text commentaire_txt = this.calendrier.createTextNode(p_commentaire);
		commentaire.appendChild(commentaire_txt);
		evenement.appendChild(commentaire);
		
		return evenement;
	}
		
	//Fonction qui effectue une recherche multi-critres (type 0 -> tous , 1 prof)
	public void recherche(String p_nom, String p_prenom, String p_ville, String p_pays, int type) throws XMLDBException
	{
		XQueryService service = (XQueryService) agenda.getService("XQueryService", "1.0");
        service.setProperty("indent", "yes");
        String requete;
        if(type == 0)
        	requete = "declare namespace c=\"http://www.domaine_general.fr\"; "
        	+"for $res in //c:contact "
        	+"where starts-with($res/c:nom,'"+p_nom+"')and starts-with($res/c:prenom,'"+p_prenom+"') and starts-with($res/c:adresse/c:ville,'"+p_ville+"') and starts-with($res/c:adresse/c:pays,'"+p_pays+"')"
        	+" order by $res/c:nom "+
        	"return $res/@c:code/string()";
        		else if (type == 1)
        	requete = "declare namespace c=\"http://www.domaine_general.fr\"; "
            	+"for $res in //c:contact "
            	+"where starts-with($res/c:nom,'"+p_nom+"')and starts-with($res/c:prenom,'"+p_prenom+"') and starts-with($res/c:adresse/c:ville,'"+p_ville+"') and starts-with($res/c:adresse/c:pays,'"+p_pays+"') and starts-with(@c:type,'prof')"
            	+" order by $res/c:nom "+
            	"return $res/@c:code/string()";
        else
        	requete =  "declare namespace c=\"http://www.domaine_general.fr\"; "
            	+"for $res in //c:contact "
            	+"where starts-with($res/c:nom,'"+p_nom+"')and starts-with($res/c:prenom,'"+p_prenom+"') and starts-with($res/c:adresse/c:ville,'"+p_ville+"') and starts-with($res/c:adresse/c:pays,'"+p_pays+"') and starts-with(@c:type,'pri')"
            	+" order by $res/c:nom "+
            	"return $res/@c:code/string()";
        ResourceSet result = service.query(requete);
        ResourceIterator i = result.getIterator();
        //System.out.println("UTILISATION XQUERY : "+requete);
        while(i.hasMoreResources()) 
        {
        	Resource r = i.nextResource();
            this.afficheContactByCode((String)r.getContent());
        }
	}
	
	public void evenementByDate(String p_jour, String p_mois, String p_annee) throws XMLDBException
	{
		XQueryService service = (XQueryService) agenda.getService("XQueryService", "1.0");
        service.setProperty("indent", "yes");
        String requete =  "//*[horaire/jour='"+p_jour+"' and horaire/mois='"+p_mois+"' and horaire/annee='"+p_annee+"']/@code/string()";
        //System.out.println("UTILISATION XQUERY : "+requete);
        ResourceSet result = service.query(requete);
        ResourceIterator i = result.getIterator();
        while(i.hasMoreResources()) 
        {
        	Resource r = i.nextResource();
            this.afficheEvenementByCode((String)r.getContent());
        }
	}
	
	public boolean evenementByDateBoolean(String p_jour, String p_mois, String p_annee) throws XMLDBException
	{
		int k = 0;
		XQueryService service = (XQueryService) agenda.getService("XQueryService", "1.0");
        service.setProperty("indent", "yes");
        String requete =  "//*[horaire/jour='"+p_jour+"' and horaire/mois='"+p_mois+"' and horaire/annee='"+p_annee+"']/@code/string()";
        System.out.println("UTILISATION XQUERY : "+requete);
        ResourceSet result = service.query(requete);
        ResourceIterator i = result.getIterator();
        while(i.hasMoreResources()) 
        {
        	k++;
        	Resource r = i.nextResource();
        	
        }
        return (k!=0)?true:false;
	}
	
	public void afficheEvenementByCode(String code) 
	{
		Element e = (Element)this.getEvenementByCode(code);
		String type = e.getAttributes().item(1).getNodeValue();
		String sujet = e.getElementsByTagName("sujet").item(0).getTextContent();
		String jour = e.getElementsByTagName("jour").item(0).getTextContent();
		String mois = e.getElementsByTagName("mois").item(0).getTextContent();
		String annee = e.getElementsByTagName("annee").item(0).getTextContent();
		String heure = e.getElementsByTagName("heure").item(0).getTextContent();
		String duree = e.getElementsByTagName("duree").item(0).getTextContent();
		String endroit = e.getElementsByTagName("endroit").item(0).getTextContent();
		String rue = e.getElementsByTagName("rue").item(0).getTextContent();
		String cp = e.getElementsByTagName("cp").item(0).getTextContent();
		String ville = e.getElementsByTagName("ville").item(0).getTextContent();
		String pays = e.getElementsByTagName("pays").item(0).getTextContent();
		String salle = e.getElementsByTagName("salle").item(0).getTextContent();
		String commentaire = e.getElementsByTagName("commentaire").item(0).getTextContent();
	
		Calendrier.ajoutLigneEvenement(code, type, sujet, jour, mois,  annee, heure,  duree,  endroit,  rue,  cp, ville,  pays,  salle,  commentaire);
	}
	
	public void afficheContactByCode(String p_code) 
	{
		String code = null;
		String type = null;
		String nom = null;
		String prenom = null;
		String rue = null;
		String cp = null;
		String ville = null;
		String pays = null;
		String jour = null;
		String mois = null;
		String annee = null;
		String email_pers = null;
		String email_prof = null;
		String fixe = null;
		String portable = null;
		String professionnel = null;
		String intitule = null;
		String raison_sociale = null;
		String rue_s = null;
		String cp_s = null;
		String ville_s = null;
		String pays_s = null;
		String web = null;
		String commentaire = null;
		
		Element contact = (Element) getContactByCode(p_code);
		
		code = p_code;
		type = contact.getAttributeNS(uri1,"type");
		nom = contact.getElementsByTagNameNS(uri1,"nom").item(0).getTextContent(); 
		prenom = contact.getElementsByTagNameNS(uri1,"prenom").item(0).getTextContent();
		rue = contact.getElementsByTagNameNS(uri1,"rue").item(0).getTextContent();
		cp = contact.getElementsByTagNameNS(uri1,"cp").item(0).getTextContent();
		ville = contact.getElementsByTagNameNS(uri1,"ville").item(0).getTextContent();
		pays = contact.getElementsByTagNameNS(uri1,"pays").item(0).getTextContent();
		Element tmp = (Element)contact.getElementsByTagNameNS(uri1,"date_naissance").item(0);
		jour = tmp.getAttributeNS(uri1,"jour");
		mois = tmp.getAttributeNS(uri1,"mois");
		annee = tmp.getAttributeNS(uri1,"annee");
		email_pers = contact.getElementsByTagNameNS(uri1,"email_pers").item(0).getTextContent();
		email_prof = contact.getElementsByTagNameNS(uri1,"email_prof").item(0).getTextContent();
		fixe = contact.getElementsByTagNameNS(uri1,"fixe").item(0).getTextContent();
		portable = contact.getElementsByTagNameNS(uri1,"portable").item(0).getTextContent();
		professionnel = contact.getElementsByTagNameNS(uri1,"professionnel").item(0).getTextContent();
		intitule = contact.getElementsByTagNameNS(uri2,"intitule").item(0).getTextContent();
		raison_sociale = contact.getElementsByTagNameNS(uri2,"raison_sociale").item(0).getTextContent();
		rue_s = contact.getElementsByTagNameNS(uri2,"rue").item(0).getTextContent();
		cp_s = contact.getElementsByTagNameNS(uri2,"cp").item(0).getTextContent();
		ville_s = contact.getElementsByTagNameNS(uri2,"ville").item(0).getTextContent();
		pays_s = contact.getElementsByTagNameNS(uri2,"pays").item(0).getTextContent();
		web = contact.getElementsByTagNameNS(uri2,"web").item(0).getTextContent(); 
		commentaire = contact.getElementsByTagNameNS(uri1,"commentaire").item(0).getTextContent();

		Interface.remplirTableauContacts( code,  type,  nom,  prenom, rue,  cp,  ville,  pays, jour,  mois,  annee,  email_pers,
				 email_prof,  fixe,  portable, professionnel,  intitule,  raison_sociale, rue_s,  cp_s,  ville_s,  pays_s, web,  commentaire);
		
	}

	public void analyseCalendrier()
	{
		Element tmp;
		NodeList nl = this.calendrier.getElementsByTagName("evenement");
		for(int i=0; i<nl.getLength(); i++)
		{
			tmp = (Element)nl.item(i);
			this.afficheEvenementByCode(tmp.getAttribute("code"));
		}
	}
	
	public void analyseContacts()
	{
		Element tmp;
		NodeList nl = this.contacts.getElementsByTagNameNS(uri1,"contact");
		for(int i=0; i<nl.getLength(); i++)
		{
			tmp = (Element)nl.item(i);
			this.afficheContactByCode(tmp.getAttributeNS(uri1,"code"));
		}
	}

	public void afficheContactPrive() throws XMLDBException
	{
		XQueryService service = (XQueryService) agenda.getService("XQueryService", "1.0");
        service.setProperty("indent", "yes");
        String requete = "declare namespace c=\"http://www.domaine_general.fr\";"+"//*[starts-with(@c:type,'priv')]/@c:code/string()";
        ResourceSet result = service.query(requete);
        ResourceIterator i = result.getIterator();
        System.out.println("UTILISATION XQUERY : "+requete);
        while(i.hasMoreResources()) 
        {
        	Resource r = i.nextResource();
            this.afficheContactByCode((String)r.getContent());
        }
		
	}
	
	public void afficheContactProfessionnel() throws XMLDBException
	{
		XQueryService service = (XQueryService) agenda.getService("XQueryService", "1.0");
        service.setProperty("indent", "yes");
        String requete = "declare namespace c=\"http://www.domaine_general.fr\";"+"//*[starts-with(@c:type,'prof')]/@c:code/string()";
        ResourceSet result = service.query(requete);
        ResourceIterator i = result.getIterator();
        System.out.println("UTILISATION XQUERY : "+requete);
        while(i.hasMoreResources()) 
        {
        	Resource r = i.nextResource();
            this.afficheContactByCode((String)r.getContent());
        }
	}
	
	public int initCodeContact(int n)
	{
		NodeList nl = this.contacts.getElementsByTagNameNS(uri1,"contact");
		Element e = null;
		for(int i = 0; i<nl.getLength() ; i++)
		{
			nl.item(i).getAttributes().item(0).setNodeValue("C"+n);
			e = (Element) nl.item(i);
			e.setIdAttributeNS(uri1,"code",true);
			n++;
		}
		return n;
	}
	
	public int initCodeEvenement(int n) 
	{
		NodeList nl = this.calendrier.getElementsByTagName("evenement");
		Element e = null;
		for(int i = 0; i<nl.getLength() ; i++)
		{
			nl.item(i).getAttributes().item(0).setNodeValue("E"+n);
			e = (Element) nl.item(i);
			e.setIdAttribute("code",true);
			n++;
		}
		return n;
	}
}