<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

  <xsl:output method="html"/>

  <xsl:template match="/">
    <html>
	<body>
	  <h1>Répertoire téléphonique</h1>
	  <xsl:apply-templates select="/repertoire/contact" mode="sommaire">
	  </xsl:apply-templates>
	  <br/>
	  <xsl:apply-templates select="/repertoire/contact" mode="details">
          </xsl:apply-templates>
	</body>
    </html>
  </xsl:template>
	
  <xsl:template match="contact" mode="sommaire">	
    <a href="{concat('#contact', position())}">
      	<xsl:value-of select="nom"/><xsl:text> </xsl:text>
	<xsl:value-of select="prenom"/>
    </a><br/>
  </xsl:template>

  <xsl:template match="contact" mode="details">	
    <a name="{concat('contact', position())}"></a>
    	<ul>
	  <li><b>
 	    <xsl:value-of select="nom"/><xsl:text> </xsl:text>
	    <xsl:value-of select="prenom"/>
     	  </b></li>
	  <xsl:value-of select="rue"/><br/>
	  <xsl:value-of select="codepostal"/><xsl:text> </xsl:text>
	  <xsl:value-of select="ville"/><br/>
	  <xsl:value-of select="pays"/><br/>
	  <xsl:apply-templates select="./telephone"></xsl:apply-templates><br/>
	</ul> 
  </xsl:template>

  <xsl:template match="telephone">
    <table>
	<xsl:apply-templates select="./numero"></xsl:apply-templates>
	<xsl:apply-templates select="../email"></xsl:apply-templates>
    </table>
  </xsl:template>

  <xsl:template match="numero">
    <tr>
	<td><b><xsl:value-of select="@type"/><xsl:text>: </xsl:text></b></td>
	<td><xsl:value-of select="."/></td>
    </tr>
  </xsl:template>	

  <xsl:template match="email">
    <tr>
	<td><b><xsl:text>mail: </xsl:text></b></td>
	<td><xsl:value-of select="."/></td>
    </tr>
  </xsl:template>
</xsl:stylesheet>


